#include<windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <shlobj.h>
#include <math.h>

#pragma warning(disable:4996)
#define _CRT_SECURE_NO_DEPRECATE 1

#include "LIB_win.h"

#include "file_Bmp_func.h"
#include "resource2.h"

void ReadMixtureGaussPalam_L_DLG(HWND hDlg,MixtureGauss* kernel_L,double adjust)
{
	int i;
	char szValue[MAX_PATH];

	//GetDlgItemText(hDlg,IDC_A_Var1,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	//if(szValue ==NULL){
	//	kernel_L->Spread[0]=atof(szValue);
	//}
	GetDlgItemText(hDlg,IDC_A_Var1,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_L->Spread[0]=atof(szValue);

	GetDlgItemText(hDlg,IDC_A_Var2,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_L->Spread[1]=atof(szValue);

	GetDlgItemText(hDlg,IDC_A_Var3,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_L->Spread[2]=atof(szValue);

	GetDlgItemText(hDlg,IDC_A_W1,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_L->Weight[0]=atof(szValue);

	GetDlgItemText(hDlg,IDC_A_W2,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_L->Weight[1]=atof(szValue);

	GetDlgItemText(hDlg,IDC_A_W3,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_L->Weight[2]=atof(szValue);

	for(i=0;i<kernel_L->Num;i++){
		kernel_L->Var[i]=pow(kernel_L->Spread[i]/adjust,2);
	}

}

void ReadMixtureGaussPalam_RG_DLG(HWND hDlg,MixtureGauss* kernel_RG,double adjust)
{
	int i;
	char szValue[MAX_PATH];

	GetDlgItemText(hDlg,IDC_T_Var1,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_RG->Spread[0]=atof(szValue);

	GetDlgItemText(hDlg,IDC_T_Var2,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_RG->Spread[1]=atof(szValue);

	GetDlgItemText(hDlg,IDC_T_W1,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_RG->Weight[0]=atof(szValue);

	GetDlgItemText(hDlg,IDC_T_W2,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_RG->Weight[1]=atof(szValue);


	for(i=0;i<kernel_RG->Num;i++){
		kernel_RG->Var[i]=pow(kernel_RG->Spread[i]/adjust,2);
	}

}

void ReadMixtureGaussPalam_BY_DLG(HWND hDlg,MixtureGauss* kernel_BY,double adjust)
{
	int i;
	char szValue[MAX_PATH];

	GetDlgItemText(hDlg,IDC_D_Var1,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_BY->Spread[0]=atof(szValue);

	GetDlgItemText(hDlg,IDC_D_Var2,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_BY->Spread[1]=atof(szValue);


	GetDlgItemText(hDlg,IDC_D_W1,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_BY->Weight[0]=atof(szValue);

	GetDlgItemText(hDlg,IDC_D_W2,(LPTSTR)szValue,(int)sizeof(szValue)-1);
	kernel_BY->Weight[1]=atof(szValue);


	for(i=0;i<kernel_BY->Num;i++){
		kernel_BY->Var[i]=pow(kernel_BY->Spread[i]/adjust,2);
	}

}

void MakeMixtureGauss_L_DLG(HWND hDlg,MixtureGauss* kernel_L,double adjust)
{
/**********************************************************************

	fn_kernel : KEXzɕKvȃp[^i[Ăt@C
	adjust : tB^TCY̒W

***********************************************************************/
	int i;
	double MaxSpread=-10000;

	//***   KEX֐ɕKvȃp[^̓ǂݍ݁@***//

	ReadMixtureGaussPalam_L_DLG(hDlg,kernel_L,adjust);
	//***  ő̕UlvZ  ******//
	for(i=0;i<kernel_L->Num;i++){
		if(kernel_L->Var[i]>=MaxSpread)MaxSpread=kernel_L->Var[i];
	}
	printf("Max spread = %f\n",MaxSpread);
	//***  tB^[TCY̌  ******//
	kernel_L->FilterSize=round(sqrt(4.0*log(2.0)*MaxSpread))-1;//tB^[TCY̌
	printf("FilterSize = %d\n",kernel_L->FilterSize);
	//***  KEX֐  ******//
	kernel_L->data=MakeMixtureGauss(kernel_L,kernel_L->FilterSize);//
	//***  f[^̎  ******//
	kernel_L->N = kernel_L->FilterSize*2 +1;

}

void MakeMixtureGauss_RG_DLG(HWND hDlg,MixtureGauss* kernel_RG,double adjust)
{
/**********************************************************************

	fn_kernel : KEXzɕKvȃp[^i[Ăt@C
	adjust : tB^TCY̒W

***********************************************************************/
	int i;
	double MaxSpread=-10000;

	//***   KEX֐ɕKvȃp[^̓ǂݍ݁@***//
	ReadMixtureGaussPalam_RG_DLG(hDlg,kernel_RG,adjust);
	//***  ő̕UlvZ  ******//
	for(i=0;i<kernel_RG->Num;i++){
		if(kernel_RG->Var[i]>=MaxSpread)MaxSpread=kernel_RG->Var[i];
	}
	printf("Max spread = %f\n",MaxSpread);
	//***  tB^[TCY̌  ******//
	kernel_RG->FilterSize=round(sqrt(4.0*log(2.0)*MaxSpread))-1;//tB^[TCY̌
	printf("FilterSize = %d\n",kernel_RG->FilterSize);
	//***  KEX֐  ******//
	kernel_RG->data=MakeMixtureGauss(kernel_RG,kernel_RG->FilterSize);//
	//***  f[^̎  ******//
	kernel_RG->N = kernel_RG->FilterSize*2 +1;

}

void MakeMixtureGauss_BY_DLG(HWND hDlg,MixtureGauss* kernel_BY,double adjust)
{
/**********************************************************************

	fn_kernel : KEXzɕKvȃp[^i[Ăt@C
	adjust : tB^TCY̒W

***********************************************************************/
	int i;
	double MaxSpread=-10000;

	//***   KEX֐ɕKvȃp[^̓ǂݍ݁@***//
	ReadMixtureGaussPalam_BY_DLG(hDlg,kernel_BY,adjust);
	//***  ő̕UlvZ  ******//
	for(i=0;i<kernel_BY->Num;i++){
		if(kernel_BY->Var[i]>=MaxSpread)MaxSpread=kernel_BY->Var[i];
	}
	printf("Max spread = %f\n",MaxSpread);
	//***  tB^[TCY̌  ******//
	kernel_BY->FilterSize=round(sqrt(4.0*log(2.0)*MaxSpread))-1;//tB^[TCY̌
	printf("FilterSize = %d\n",kernel_BY->FilterSize);
	//***  KEX֐  ******//
	kernel_BY->data=MakeMixtureGauss(kernel_BY,kernel_BY->FilterSize);//
	//***  f[^̎  ******//
	kernel_BY->N = kernel_BY->FilterSize*2 +1;

}

void Make_ATD_FILTER_Win_fromDLG(HWND hDlg,Atd_Filter *atd,double adjust)
{
	//	//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	//**:::::::::     ATDtB^[̍쐬    ::::::::::::::::::::::::::::::::
	//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	/***********************************************************************
	ATDtB^[0gSɂ悤ɐݒ

	*************************************************************************/

	//****    ԂłLARGABYtB^[쐬     *******
	//Atd_Filter atd;
	MakeMixtureGauss_L_DLG(hDlg,&atd->kernel_L,adjust);
	MakeMixtureGauss_RG_DLG(hDlg,&atd->kernel_RG,adjust);
	MakeMixtureGauss_BY_DLG(hDlg,&atd->kernel_BY,adjust);

	//****    RGABYtB^[̃TCYLtB^[̃TCY֍킹     *******
	int FilterSizeMax = atd->kernel_L.FilterSize;
	if(FilterSizeMax != atd->kernel_RG.FilterSize){
		atd->kernel_RG.data=ReNewDataSizeATD(&atd->kernel_RG,FilterSizeMax);
	}
	if(FilterSizeMax != atd->kernel_BY.FilterSize){
		atd->kernel_BY.data=ReNewDataSizeATD(&atd->kernel_BY,FilterSizeMax);
	}
	//***   t[GԂłLARGABYtB^[̃p[XyNg     *******
	atd->kernel_L.ps=ATD_FouierFilter(&atd->kernel_L);
	atd->kernel_RG.ps=ATD_FouierFilter(&atd->kernel_RG);
	atd->kernel_BY.ps=ATD_FouierFilter(&atd->kernel_BY);

	//***   t[GԂłLARGABYtB^[̋Ki  *******
	NormalizedATD(&atd->kernel_L);
	NormalizedATD(&atd->kernel_RG);
	NormalizedATD(&atd->kernel_BY);

	//FLAG_ATD = 1;

	//return atd;

}

void READ_ATD_FILTER_Win(HWND hDlg,Atd_Filter *atd,double adjust,char *szProfileAdress)
{
	//	//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
	//**:::::::::     ATDtB^[̍쐬    ::::::::::::::::::::::::::::::::
	//:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

	/***********************************************************************
	ATDtB^[0gSɂ悤ɐݒ

	*************************************************************************/

	FILE *fp;

	char fn_L_path[MAX_PATH];
	char fn_RG_path[MAX_PATH];
	char fn_BY_path[MAX_PATH];
	char temp[MAX_PATH];


	strcpy(fn_L_path,szProfileAdress);
	strcpy(fn_RG_path,szProfileAdress);
	strcpy(fn_BY_path,szProfileAdress);

	strcat(fn_L_path,fn_L);
	strcat(fn_RG_path,fn_RG);
	strcat(fn_BY_path,fn_BY);

	if((fp=fopen(fn_L_path,"r")) == NULL)
	{
		MessageBox(hDlg,
			(LPCSTR)"PROFILE DATA tH_AhXԈĂ܂!! \n",
			(LPCSTR)"FILE OPEN ERROR",
			MB_OK | MB_ICONINFORMATION);
	}else{
		fclose(fp);
		//****    ԂłLARGABYtB^[쐬     *******
		
		atd->kernel_L=MakeMixtureGauss(fn_L_path,adjust);
		atd->kernel_RG=MakeMixtureGauss(fn_RG_path,adjust);
		atd->kernel_BY=MakeMixtureGauss(fn_BY_path,adjust);

		sprintf(temp,"%.4f",atd->kernel_L.Spread[0]);
		SetDlgItemText(hDlg,IDC_A_Var1,(LPTSTR)temp);
		sprintf(temp,"%.4f",atd->kernel_L.Spread[1]);
		SetDlgItemText(hDlg,IDC_A_Var2,(LPTSTR)temp);
		sprintf(temp,"%.4f",atd->kernel_L.Spread[2]);
		SetDlgItemText(hDlg,IDC_A_Var3,(LPTSTR)temp);

		sprintf(temp,"%.4f",atd->kernel_L.Weight[0]);
		SetDlgItemText(hDlg,IDC_A_W1,(LPTSTR)temp);
		sprintf(temp,"%.4f",atd->kernel_L.Weight[1]);
		SetDlgItemText(hDlg,IDC_A_W2,(LPTSTR)temp);
		sprintf(temp,"%.4f",atd->kernel_L.Weight[2]);
		SetDlgItemText(hDlg,IDC_A_W3,(LPTSTR)temp);

		
		sprintf(temp,"%.4f",atd->kernel_RG.Spread[0]);
		SetDlgItemText(hDlg,IDC_T_Var1,(LPTSTR)temp);
		sprintf(temp,"%.4f",atd->kernel_RG.Spread[1]);
		SetDlgItemText(hDlg,IDC_T_Var2,(LPTSTR)temp);

		sprintf(temp,"%.4f",atd->kernel_RG.Weight[0]);
		SetDlgItemText(hDlg,IDC_T_W1,(LPTSTR)temp);
		sprintf(temp,"%.4f",atd->kernel_RG.Weight[1]);
		SetDlgItemText(hDlg,IDC_T_W2,(LPTSTR)temp);

				
		sprintf(temp,"%.4f",atd->kernel_BY.Spread[0]);
		SetDlgItemText(hDlg,IDC_D_Var1,(LPTSTR)temp);
		sprintf(temp,"%.4f",atd->kernel_BY.Spread[1]);
		SetDlgItemText(hDlg,IDC_D_Var2,(LPTSTR)temp);

		sprintf(temp,"%.4f",atd->kernel_BY.Weight[0]);
		SetDlgItemText(hDlg,IDC_D_W1,(LPTSTR)temp);
		sprintf(temp,"%.4f",atd->kernel_BY.Weight[1]);
		SetDlgItemText(hDlg,IDC_D_W2,(LPTSTR)temp);

	}

}