//#include "stdafx.h"

#include <math.h>
#include "Palam.h"
#include "DFT.h"


void DFT1D(double *xr,double *xi,double *ur,double *ui,int ir,int N)
{
/***********************************************************
		2007/10/29@쐬

		1g`̃t[Gϊ@
		̈̃f[^xr[0]_ɂȂ悤ɔzu
		g̈̌_xr[0]ɂȂiבւĂȂj

		f[^̓t@Ĉ͎݁@0
		ir=1̂Ƃt[Gϊ@ir=-1̂Ƃt[Gtϊ

		́@xr[],xi[]  o ur[],ui[]
		ir=1̂Ƃt[GϊAir=-1̂Ƃt[Gtϊ
		N ̓f[^

*************************************************************/

	int i,j,nn;

	if(ir == 1) nn = 1;//t[Gϊ̏ꍇ
	else        nn = N;//t[Gtϊ̏ꍇ
	//t[Gϊ̌vZ
	for(i = 0 ; i < N ; i++) {
	  ur[i] = xr[0];
	  ui[i] = xi[0];
	  for(j = 1 ; j < N ; j++) {
	    ur[i] +=  xr[j]*cos(2*PI*i*j/N)+ir*xi[j]*sin(2*PI*i*j/N);
	    ui[i] += -ir*xr[j]*sin(2*PI*i*j/N)+xi[j]*cos(2*PI*i*j/N);
	  }
	}
	for(i = 0 ; i < N ; i++) {
	  xr[i] = ur[i]/nn;
	  xi[i] = ui[i]/nn;
	}

}

void DFT1D(double *xr,double *xi,int ir,int N)
{
/***********************************************************
		2007/10/29@쐬

		1g`̃t[Gϊ@
		̈̃f[^xr[0]_ɂȂ悤ɔzu
		g̈̌_xr[0]ɂȂiבւĂȂj

		f[^̓t@Ĉ͎݁@0
		ir=1̂Ƃt[Gϊ@ir=-1̂Ƃt[Gtϊ

		́@xr[],xi[]  o ur[],ui[]
		ir=1̂Ƃt[GϊAir=-1̂Ƃt[Gtϊ
		N ̓f[^

*************************************************************/

	int i,j,nn;
	double *ur,*ui;

	ur = new double [N];
	ui = new double [N];

	if(ir == 1) nn = N;//t[Gϊ̏ꍇ
	else        nn = 1;//t[Gtϊ̏ꍇ
	//t[Gϊ̌vZ
	for(i = 0 ; i < N ; i++) {
	  ur[i] = xr[0];
	  ui[i] = xi[0];
	  for(j = 1 ; j < N ; j++) {
	    ur[i] +=  xr[j]*cos(2*PI*i*j/N)+ir*xi[j]*sin(2*PI*i*j/N);
	    ui[i] += -ir*xr[j]*sin(2*PI*i*j/N)+xi[j]*cos(2*PI*i*j/N);
	  }
	}
	for(i = 0 ; i < N ; i++) {
	  xr[i] = ur[i]/nn;
	  xi[i] = ui[i]/nn;
	}

	delete []ur;
	delete []ui;

}

void DFT2D(double *dimg_r,double *dimg_i,int ir,int NX,int NY)
{
	/***********************************************************
		2007/10/29@쐬

		摜̃t[Gϊ@@Qt[Gϊ@
	
		͉摜@摜@dimg_r[],@摜dimg_i[]
		
		1DFTւ̓́@xr[],xi[]  @ur[],ui[]͌vZ̈
		ir=1̂Ƃt[GϊAir=-1̂Ƃt[Gtϊ
		N ̓f[^

*************************************************************/
	int i,j;
	double *xr;
	double *xi;
	int N;// N = max(NX,NY)
	if(NX>=NY)N = NX;
	else N = NY;

	xr = new double [N];
	xi = new double [N];

	//esDFT@
	for(j = 0 ; j < NY ; j++){ 
		for(i = 0 ; i < NX ; i++) {
			xr[i]=dimg_r[j*NX+i];
			xi[i]=dimg_i[j*NX+i];
		}
		DFT1D(xr,xi,ir,NX);//t[Gϊ
		for(i = 0 ; i < NX ; i++) {
			dimg_r[j*NX+i]=xr[i];
			dimg_i[j*NX+i]=xi[i];
		}
	}

	//eDFT@
	for(i = 0 ; i < NX ; i++) {
		for(j = 0 ; j < NY ; j++){ 
			xr[j]=dimg_r[j*NX+i];
			xi[j]=dimg_i[j*NX+i];
		}
		DFT1D(xr,xi,ir,NY);//t[Gϊ
		for(j = 0 ; j < NY ; j++){ 
			dimg_r[j*NX+i]=xr[j];
			dimg_i[j*NX+i]=xi[j];
		}
	}

	delete []xr;
	delete []xi;

}

void DFT2D(double *dimg_r,double *dimg_i,
		   double *xr,double *xi,double *ur,double *ui,int ir,int NX,int NY)
{
	/***********************************************************
		2007/10/29@쐬

		摜̃t[Gϊ@@Qt[Gϊ@
	
		͉摜@摜@dimg_r[],@摜dimg_i[]
		
		1DFTւ̓́@xr[],xi[]  @ur[],ui[]͌vZ̈
		ir=1̂Ƃt[GϊAir=-1̂Ƃt[Gtϊ
		N ̓f[^

*************************************************************/
	int i,j;

	//esDFT@
	for(j = 0 ; j < NY ; j++){ 
		for(i = 0 ; i < NX ; i++) {
			xr[i]=dimg_r[j*NX+i];
			xi[i]=dimg_i[j*NX+i];
		}
		DFT1D(xr,xi,ur,ui,ir,NX);//t[Gϊ
		for(i = 0 ; i < NX ; i++) {
			dimg_r[j*NX+i]=xr[i];
			dimg_i[j*NX+i]=xi[i];
		}
	}

	//eDFT@
	for(i = 0 ; i < NX ; i++) {
		for(j = 0 ; j < NY ; j++){ 
			xr[j]=dimg_r[j*NX+i];
			xi[j]=dimg_i[j*NX+i];
		}
		DFT1D(xr,xi,ur,ui,ir,NY);//t[Gϊ
		for(j = 0 ; j < NY ; j++){ 
			dimg_r[j*NX+i]=xr[j];
			dimg_i[j*NX+i]=xi[j];
		}
	}


}

void PowerImg(double *dimg_r,double *dimg_i,int NX,int NY,double RANGE,unsigned char *out_img)
{
/***********************************************************
		2007/10/29@쐬

		t[Gϊ̃p[XyNg摜o͂֐
	
		͉摜 (double^)@摜@dimg_r[],@摜dimg_i[]
		o͉摜 (unsigned char^)  out_img[]
		摜TCY	[NX,NY]

		_Ci~bNW@RANGE

*************************************************************/

	int i,j;
	double max=0,d,db;
	double dr,di;
	double *tmp;

	tmp = new double[NX*NY];

	for(j = 0 ; j < NY ; j++){ 
		for(i = 0 ; i < NX ; i++) {
			dr=dimg_r[j*NX+i]/255.0;
			di=dimg_i[j*NX+i]/255.0;

			d=pow(dr,(int)2)+pow(di,(int)2);
			if(d == 0.0) db=0.0;
			else db = 10.0 * log10(d) + RANGE;

			if( db < 0.0 ) db = 0.0;
			if( max < db ) max = db;

			tmp[j*NX+i]=db;

		}
	}

	for(j = 0 ; j < NY ; j++){ 
		for(i = 0 ; i < NX ; i++) {
				out_img[j*NX+i] = (unsigned char)(255.0 * tmp[j*NX+i]/max);
		}
	}

	delete []tmp;

}

void FImgShift(double *img,int NX,int NY)
{
	/***********************************************************
		2007/10/29@쐬

		t[Gϊ摜ѕς֐
		1ی@Ɓ@4ی
		2ی@Ɓ@3ی

		͉摜 (double^)@img[]
		o͉摜 (double^)  img[]@(͉̓摜u)
		摜TCY	[NX,NY]

*************************************************************/

	int i,j;
	double a;
	//ъ
	for(j = 0; j < NY/2; j++)
	{
		for(i = 0;i < NX/2; i++)// ƉE
		{
			a = img[j*NX+i];
			img[j*NX+i] = img[(j+NY/2)*NX+(i+NX/2)];
			img[(j+NY/2)*NX+(i+NX/2)]=a;
		}

		for(i = NX/2;i < NX; i++)// Eƍ
		{
			a = img[j*NX+i];
			img[j*NX+i] = img[(j+NY/2)*NX+(i-NX/2)];
			img[(j+NY/2)*NX+(i-NX/2)]=a;
		}
	}

}

void FImgShift(unsigned char *img,int NX,int NY)
{
	/***********************************************************
		2007/10/29@쐬

		t[Gϊ摜ѕς֐
		1ی@Ɓ@4ی
		2ی@Ɓ@3ی
	
		͉摜 (unsigned char^)@img[]
		o͉摜 (unsigned char^)  img[]@(͉̓摜u)
		摜TCY	[NX,NY]

*************************************************************/

	int i,j;
	unsigned char a;
	//ъ
	for(j = 0; j < NY/2; j++)
	{
		for(i = 0;i < NX/2; i++)// ƉE
		{
			a = img[j*NX+i];
			img[j*NX+i] = img[(j+NY/2)*NX+(i+NX/2)];
			img[(j+NY/2)*NX+(i+NX/2)]=a;
		}

		for(i = NX/2;i < NX; i++)// Eƍ
		{
			a = img[j*NX+i];
			img[j*NX+i] = img[(j+NY/2)*NX+(i-NX/2)];
			img[(j+NY/2)*NX+(i-NX/2)]=a;
		}
	}

}

void FImgShift1D(double *data,int N)
{
	/***********************************************************
		2007/11/20@쐬

		1t[Gϊf[^ѕς֐

		͉摜 (double^)@data[]
		o͉摜 (double^)  data[]@(͉̓摜u)
		f[^TCY	[N]

*************************************************************/
	int i;
	double a,b;
	//ъ	

	if(N%2==0){
		for(i = 0;i < N/2; i++)// ƉE
		{
			a = data[i];
			data[i] = data[(i+N/2)];
			data[(i+N/2)]=a;
		}

	}else{//̏ꍇ
		//b=N/2;
		b=data[N/2];
		for(i = 0;i < N/2; i++)
		{
			a = data[i];
			data[i] = data[(i+N/2+1)];
			data[(i+N/2)]=a;
		}
		data[N-1] =b;
	}

}

void Lowpass_fil(double *filter,int nx,int ny,int cutoff)
{
		/***********************************************************
		2007/10/29@쐬

		lowpass tB^[𐶐֐

*************************************************************/
	int i,j;

	for(j = 0 ; j < ny ; j++){//摜_u^֓ 
		for(i = 0 ; i < nx ; i++) {
			if(nx/2-cutoff<=i&&i<=nx/2+cutoff&&ny/2-cutoff<=j&&j<=ny/2+cutoff){
				filter[nx*j+i]=1;
			}
			else filter[nx*j+i]=0;
		}
	}
}

void PowerSpect(double *re,double *im,int N,double *ps)
{
/***********************************************************
		2007/12/2@쐬

		t[Gϊ̃p[XyNgo͂֐
	
		̓XyNg (double^)@@re[],@@im[]
		o̓XyNg  ps[]
		TCY	[N]

*************************************************************/

	int i;

	for(i = 0 ; i < N ; i++) {
		ps[i]=sqrt(pow(re[i],(int)2)+pow(im[i],(int)2));
	}
}