//#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "memory_allocate.h"
#include "Gauss.h"
#include "CRGB.h"
#include "MSI.h"
//#include "S_CIELAB.h"
#include "TABLE.h"


#pragma warning(disable:4996)
#define _CRT_SECURE_NO_DEPRECATE 1

void MSIGetInfo(char *fn,int *Size,int *X,int *Y,int *Band)
{
	FILE *fp;


	if((fp = fopen(fn, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	*Size=ftell(fp);
	fseek(fp,  0L, SEEK_SET);

	if(*Size==MSI_Size1){
		printf("16oh摜i摜ƍ摜Ljwb_[摜\n");
		printf("摜ƍ摜Ĕz֊i[\n");
		printf("x=2048,y=2048\n");
		*X=2048;
		*Y=2048;
		*Band=16;
	}

	if(*Size==MSI_Size2){
		printf("16oh摜i摜ƍ摜jwb_[摜\n");
		printf("x=2048,y=2048\n");
		*X=2048;
		*Y=2048;
		*Band=16;
	}

	fclose(fp);
}

void MSIGetData(char *fn,int Size,int X,int Y,int Band,unsigned short int *MSI)
{
	FILE *fp;
	int i,j,k;
	unsigned short int Dg;
	int ReadBand;

	if(Size==MSI_Size1){//16oh摜i摜ƍ摜Ljwb_[摜
		unsigned short int *DATA;
		DATA=usvector(0,Size/sizeof(unsigned short int));		
		ReadBand=Size/(sizeof(unsigned short int)*X*Y);
		
		if((fp = fopen(fn, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn);
		exit(1);
		}
		fread(DATA,sizeof(unsigned short int),Size/sizeof(unsigned short int),fp);
		fclose(fp);

		for(i=0;i<Y;i++){
			for(j=0;j<X;j++){
				Dg=DATA[i*X*ReadBand+j*ReadBand];
				for(k=0;k<Band;k++){

					if(DATA[i*X*ReadBand+j*ReadBand+k+1]-Dg<0){
						MSI[i*X*Band+j*Band+k]=0;
					}else{
						MSI[i*X*Band+j*Band+k]=DATA[i*X*ReadBand+j*ReadBand+k+1]-Dg;
					}

				}
			}
		}

		free_usvector(DATA,0,Size/sizeof(unsigned short int));


	}

	if(Size==MSI_Size2){//16oh摜i摜ƍ摜jwb_[摜
		if((fp = fopen(fn, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn);
		getchar();
		exit(1);
		}
		fread(MSI,sizeof(unsigned short int),Size/sizeof(unsigned short int),fp);
		fclose(fp);
		
	}

	fclose(fp);
}

MSI MSI_wSig(char *fn)
{
	FILE *fp;
	MSI wg;
	int i,j,k;
	unsigned short int *DATA;
	unsigned short int Dg;
	double *ag;//average of signal
	int ReadBand;
	int SquareSize=100;
	int SIZE;

	wg.fn=fn;	
	if((fp = fopen(fn, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn);
		getchar();
		exit(1);
	}
	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	wg.SIZE=ftell(fp);
	fseek(fp,  0L, SEEK_SET);
	
	if(wg.SIZE==MSI_Size1){
		printf("16oh摜i摜ƍ摜Ljwb_[摜\n");
		printf("摜ƍ摜Ĕz֊i[\n");
		printf("x=2048,y=2048\n");
		wg.X=2048;
		wg.Y=2048;
		wg.BAND=16;
		wg.data=usvector(0,wg.BAND);


	}else if(wg.SIZE==MSI_Size2){
		printf("16oh摜i摜ƍ摜jwb_[摜\n");
		printf("x=2048,y=2048\n");
		wg.X=2048;
		wg.Y=2048;
		wg.BAND=16;
		wg.data=usvector(0,wg.BAND);

	}else{		
		SIZE=wg.SIZE/sizeof(unsigned short int);
		wg.X=2048;
		wg.Y=2048;
		wg.BAND=int(SIZE/(wg.X*wg.Y));
		wg.data=usvector(0,wg.BAND);
		printf("%doh摜i摜ƍ摜jwb_[摜\n",wg.BAND);
		printf("x=2048,y=2048\n");


	}
	
	ag=dvector(0,wg.BAND);
	for(k=0;k<wg.BAND;k++){
		ag[k]=0;
	}	

	if(wg.SIZE==MSI_Size1){
		ReadBand=wg.SIZE/(sizeof(unsigned short int)*wg.X*wg.Y);
	}else{
		ReadBand=wg.BAND;
	}
	DATA=usvector(0,ReadBand);	

	
	for(i=wg.Y/2-SquareSize/2;i<wg.Y/2+SquareSize/2;i++){
		for(j=wg.X/2-SquareSize/2;j<wg.X/2+SquareSize/2;j++){
			if(wg.SIZE==MSI_Size2){
				fseek(fp,(long)(i-1)*wg.X*ReadBand*sizeof(unsigned short int)
					+j*ReadBand*sizeof(unsigned short int)+MSI_Size2_HEADER,SEEK_SET);		
			}else{
				fseek(fp,(long)(i-1)*wg.X*ReadBand*sizeof(unsigned short int)
					+j*ReadBand*sizeof(unsigned short int),SEEK_SET);		
			}
			fread(DATA,sizeof(unsigned short int),ReadBand,fp);
			
			if(wg.SIZE==MSI_Size1){//16oh摜i摜ƍ摜Ljwb_[摜
				Dg=DATA[0];
				for(k=0;k<wg.BAND;k++){
					if(DATA[k+1]-Dg<0){
						ag[k]+=0;
					}else{
						ag[k]+=DATA[k+1]-Dg;
					}
				}
			}else{//i摜ƍ摜)
				for(k=0;k<wg.BAND;k++){
					ag[k]+=DATA[k];
				}
			}
		}
	}
	
	fclose(fp);

	for(k=0;k<wg.BAND;k++){
		wg.data[k]=(unsigned short int)(ag[k]/(SquareSize*SquareSize));
	}

	free_usvector(DATA,0,ReadBand);
	free_dvector(ag,0,wg.BAND);

	return wg;

}

MSI MSIGet(char *fn)
{
	FILE *fp;
	MSI wg;
	int i,j,k;
	unsigned short int Dg;
	int ReadBand;
	int SIZE;

	wg.fn=fn;	
	if((fp = fopen(fn, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn);
		getchar();
		exit(1);
	}
	printf("MSI is %s\n",wg.fn);
	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	wg.SIZE=ftell(fp);
	fseek(fp,  0L, SEEK_SET);

	
	if(wg.SIZE==MSI_Size1){
		printf("16oh摜i摜ƍ摜Ljwb_[摜\n");
		printf("摜ƍ摜Ĕz֊i[\n");
		printf("x=2048,y=2048\n");
		wg.X=2048;
		wg.Y=2048;
		wg.BAND=16;
		wg.data=usvector(0,wg.BAND*wg.X*wg.Y);

	}else if(wg.SIZE==MSI_Size2){
		printf("16oh摜i摜ƍ摜jwb_[摜\n");
		printf("x=2048,y=2048\n");
		wg.X=2048;
		wg.Y=2048;
		wg.BAND=16;
		wg.data=usvector(0,wg.BAND*wg.X*wg.Y);

	}else{

		SIZE=wg.SIZE/sizeof(unsigned short int);
		wg.X=2048;
		wg.Y=2048;
		wg.BAND=int(SIZE/(wg.X*wg.Y));
		wg.data=usvector(0,wg.BAND*wg.X*wg.Y);
		printf("%doh摜i摜ƍ摜jwb_[摜\n",wg.BAND);
		printf("x=2048,y=2048\n");

	}
	
	if(wg.SIZE==MSI_Size1){//16oh摜i摜ƍ摜Ljwb_[摜
		unsigned short int *DATA;
		DATA=usvector(0,wg.SIZE/sizeof(unsigned short int));		
		ReadBand=wg.SIZE/(sizeof(unsigned short int)*wg.X*wg.Y);
		
		if((fp = fopen(fn, "rb")) == NULL ) {
			printf("%s I[vG[\n",fn);
			exit(1);
		}
		fread(DATA,sizeof(unsigned short int),wg.SIZE/sizeof(unsigned short int),fp);
		fclose(fp);
		
		for(i=0;i<wg.Y;i++){
			for(j=0;j<wg.X;j++){
				Dg=DATA[i*wg.X*ReadBand+j*ReadBand];
				for(k=0;k<wg.BAND;k++){

					if(DATA[i*wg.X*ReadBand+j*ReadBand+k+1]-Dg<0){
						wg.data[i*wg.X*wg.BAND+j*wg.BAND+k]=0;
					}else{
						wg.data[i*wg.X*wg.BAND+j*wg.BAND+k]=DATA[i*wg.X*ReadBand+j*ReadBand+k+1]-Dg;
					}

				}
			}
		}
		
		free_usvector(DATA,0,wg.SIZE/sizeof(unsigned short int));
		
		
	}else if(wg.SIZE==MSI_Size2){//16oh摜i摜ƍ摜jwb_[摜
		if((fp = fopen(fn, "rb")) == NULL ) {
			printf("%s I[vG[\n",fn);
			getchar();
			exit(1);
		}
		fseek(fp,MSI_Size2_HEADER, SEEK_SET);
		fread(wg.data,sizeof(unsigned short int),wg.BAND*wg.X*wg.Y,fp);
		fclose(fp);
		
	}else{
		if((fp = fopen(fn, "rb")) == NULL ) {
			printf("%s I[vG[\n",fn);
			getchar();
			exit(1);
		}
		fread(wg.data,sizeof(unsigned short int),wg.BAND*wg.X*wg.Y,fp);
		fclose(fp);
	}

	return wg;

}

RGB RGBinfo(MSI *msi,char *fn)
{
	RGB rgb;
	//char temp[200];
//	ReName(msi->fn,temp,"_rgb.raw");
//	rgb.fn=temp;
	rgb.fn=fn;
	rgb.X=msi->X;
	rgb.Y=msi->Y;
	rgb.BAND=3;
	rgb.data=ucvector(0,rgb.X*rgb.Y*rgb.BAND);

	return rgb;
}

void USimgConvertRGB(MSI *msi)
{
	FILE *fp;
	unsigned char *cg;
	int SIZE;
	int i;

	char refn[200];

	ReName(msi->fn,refn,"_char.raw");
	printf("%s\n",refn);
	
	SIZE=msi->X*msi->Y*msi->BAND;

	printf("f[^ = %d@\n",SIZE);
	cg=ucvector(0,SIZE);

	for(i=0;i<SIZE;i++){
		cg[i]=(unsigned char)(msi->data[i]/255);
		if(cg[i]<0)cg[i]=0;
		if(cg[i]>255)cg[i]=255;
	}

	if((fp = fopen(refn, "wb")) == NULL ) {
		printf("%s I[vG[\n",refn);
		getchar();
		exit(1);
	}
	fwrite(cg,sizeof(unsigned char),SIZE,fp);
	fclose(fp);

	free_ucvector(cg,0,SIZE);
	

}

MSI MSIinfoCOPY(MSI *msi)
{
	MSI cmsi;
	cmsi.X=msi->X;
	cmsi.Y=msi->Y;
	cmsi.BAND=msi->BAND;
	cmsi.data=usvector(0,cmsi.X*cmsi.Y*cmsi.BAND);

	return cmsi;
}

void WO_DARK_THROUGH(char *fn_msi)
{
	MSI msi;//Multi Spectral Image of object	
	msi.fn=fn_msi;//"..\\DATA\\HE3.001";
	msi=MSIGet(msi.fn);

	FILE *fp;
	char fn_womsi[200];//KLW摜̃t@Ci[z
	ReName(msi.fn,fn_womsi,"_wo.raw");//KLW摜̃t@C@[raw`] _
	printf("%s\n",fn_womsi);


	if((fp = fopen(fn_womsi, "wb")) == NULL ) {//rawint^o
		printf("%s I[vG[\n",fn_womsi);
		getchar();
		exit(1);
	}
	fwrite(msi.data,sizeof(unsigned short int),msi.X*msi.Y*msi.BAND,fp);
	fclose(fp);

	free_usvector(msi.data,0,msi.X*msi.Y*msi.BAND);


}

MSI MSIGet_V2(char *fn)
{
	FILE *fp;
	MSI wg;
	int i,j,k;
	unsigned short int Dg;
	int ReadBand;
	int SIZE;

	wg.fn=fn;	
	if((fp = fopen(fn, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn);
		getchar();
		exit(1);
	}
	printf("MSI is %s\n",wg.fn);
	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	wg.SIZE=ftell(fp);
	fseek(fp,  0L, SEEK_SET);

	
	if(wg.SIZE==MSI_Size1){
		printf("16oh摜i摜ƍ摜Ljwb_[摜\n");
		printf("摜ƍ摜Ĕz֊i[\n");
		printf("x=2048,y=2048\n");
		wg.X=2048;
		wg.Y=2048;
		wg.BAND=16;
		wg.data=usvector(0,wg.BAND*wg.X*wg.Y);

	}else if(wg.SIZE==MSI_Size2){
		printf("16oh摜i摜ƍ摜jwb_[摜\n");
		printf("x=2048,y=2048\n");
		wg.X=2048;
		wg.Y=2048;
		wg.BAND=16;
		wg.data=usvector(0,wg.BAND*wg.X*wg.Y);

	}else if(wg.SIZE==IMSPEC_Size){
		printf("81oh摜\n");
		printf("x=322,y=480\n");
		wg.X=322;
		wg.Y=480;
		wg.BAND=81;
		wg.data=usvector(0,wg.BAND*wg.X*wg.Y);

		wg.IM_wx=0;// Position of white current when IMSPECTOR image is used
		wg.IM_dx=1;// Position of dark current when IMSPECTOR image is used
		wg.IM_sx=2;// Starting position of image when IMSPECTOR image is used  

	}else{

		SIZE=wg.SIZE/sizeof(unsigned short int);
		wg.X=2048;
		wg.Y=2048;
		wg.BAND=int(SIZE/(wg.X*wg.Y));
		wg.data=usvector(0,wg.BAND*wg.X*wg.Y);
		printf("%doh摜i摜ƍ摜jwb_[摜\n",wg.BAND);
		printf("x=2048,y=2048\n");

	}
	
	if(wg.SIZE==MSI_Size1){//16oh摜i摜ƍ摜Ljwb_[摜
		unsigned short int *DATA;
		DATA=usvector(0,wg.SIZE/sizeof(unsigned short int));		
		ReadBand=wg.SIZE/(sizeof(unsigned short int)*wg.X*wg.Y);
		
		if((fp = fopen(fn, "rb")) == NULL ) {
			printf("%s I[vG[\n",fn);
			exit(1);
		}
		fread(DATA,sizeof(unsigned short int),wg.SIZE/sizeof(unsigned short int),fp);
		fclose(fp);
		
		for(i=0;i<wg.Y;i++){
			for(j=0;j<wg.X;j++){
				Dg=DATA[i*wg.X*ReadBand+j*ReadBand];
				for(k=0;k<wg.BAND;k++){

					if(DATA[i*wg.X*ReadBand+j*ReadBand+k+1]-Dg<0){
						wg.data[i*wg.X*wg.BAND+j*wg.BAND+k]=0;
					}else{
						wg.data[i*wg.X*wg.BAND+j*wg.BAND+k]=DATA[i*wg.X*ReadBand+j*ReadBand+k+1]-Dg;
					}

				}
			}
		}
		
		free_usvector(DATA,0,wg.SIZE/sizeof(unsigned short int));
		
		
	}else if(wg.SIZE==MSI_Size2){//16oh摜i摜ƍ摜jwb_[摜
		if((fp = fopen(fn, "rb")) == NULL ) {
			printf("%s I[vG[\n",fn);
			getchar();
			exit(1);
		}
		fseek(fp,MSI_Size2_HEADER, SEEK_SET);
		fread(wg.data,sizeof(unsigned short int),wg.BAND*wg.X*wg.Y,fp);
		fclose(fp);
		
	}else if(wg.SIZE==IMSPEC_Size){//16oh摜i摜ƍ摜jwb_[摜
		if((fp = fopen(fn, "rb")) == NULL ) {
			printf("%s I[vG[\n",fn);
			getchar();
			exit(1);
		}
		fread(wg.data,sizeof(unsigned short int),wg.BAND*wg.X*wg.Y,fp);
		fclose(fp);
		
	}else{
		if((fp = fopen(fn, "rb")) == NULL ) {
			printf("%s I[vG[\n",fn);
			getchar();
			exit(1);
		}
		fread(wg.data,sizeof(unsigned short int),wg.BAND*wg.X*wg.Y,fp);
		fclose(fp);
	}

	return wg;

}

unsigned char* GetCharImg(char *fn,int *Num)
{
	FILE *fp;
	unsigned char *data;
	int SIZE;//,Num;


	if((fp = fopen(fn, "rb")) == NULL ) {
		printf("%s I[vG[\n",fn);
		getchar();
		exit(1);
	}

	fseek(fp,  0L, SEEK_END);
	printf("t@CTCY = %ld@oCg\n",ftell(fp));
	SIZE=ftell(fp);
	fseek(fp,  0L, SEEK_SET);

	*Num=(int)SIZE/(sizeof(unsigned char));//f
	data=ucvector(0,(*Num));

	fread(data,sizeof(unsigned char),(*Num),fp);
	fclose(fp);

	return data;


}


