void cdft(int n, int isgn, double *a, int *ip, double *w);
void rdft(int n, int isgn, double *a, int *ip, double *w);
void ddct(int n, int isgn, double *a, int *ip, double *w);
void ddst(int n, int isgn, double *a, int *ip, double *w);
void dfct(int n, double *a, double *t, int *ip, double *w);
void dfst(int n, double *a, double *t, int *ip, double *w);


void makewt(int nw, int *ip, double *w);
void makeipt(int nw, int *ip);
void makect(int nc, int *ip, double *c);

/* -------- child routines -------- */
void cftfsub(int n, double *a, int *ip, int nw, double *w);
void cftbsub(int n, double *a, int *ip, int nw, double *w);
void bitrv2(int n, int *ip, double *a);
void bitrv2conj(int n, int *ip, double *a);
void bitrv216(double *a);
void bitrv216neg(double *a);
void bitrv208(double *a);
void bitrv208neg(double *a);
void cftf1st(int n, double *a, double *w);
void cftb1st(int n, double *a, double *w);
void cftrec4_th(int n, double *a, int nw, double *w);
void *cftrec1_th(void *p);
void *cftrec2_th(void *p);
void cftrec4(int n, double *a, int nw, double *w);
int cfttree(int n, int j, int k, double *a, int nw, double *w);
void cftleaf(int n, int isplt, double *a, int nw, double *w);
void cftmdl1(int n, double *a, double *w);
void cftmdl2(int n, double *a, double *w);
void cftfx41(int n, double *a, int nw, double *w);
void cftf161(double *a, double *w);
void cftf162(double *a, double *w);
void cftf081(double *a, double *w);
void cftf082(double *a, double *w);
void cftf040(double *a);
void cftb040(double *a);
void cftx020(double *a);
void rftfsub(int n, double *a, int nc, double *c);
void rftbsub(int n, double *a, int nc, double *c);
void dctsub(int n, double *a, int nc, double *c);
void dstsub(int n, double *a, int nc, double *c);